# this source RPM supports building on OpenLinux and UnitedLinux
# The PLATFORM keyword appears in comments next to the platform specific areas.
%define OpenLinux	[ -d /home/httpd/html/openlinux_help ]
%define NotOpenLinux	[ ! -d /home/httpd/html/openlinux_help ]
# PLATFORM
# ol
%define _manprefixol    %{_mandir}%{manEN}
%define _svidirol       /etc/rc.d/init.d
%define _perldirol      /usr/lib/perl5/5.6.0/i386-linux
%define _perlpdirol     /usr/lib/perl5/site-perl/i386-linux

# ul
%define _manprefixul    %{_mandir}
%define _svidirul       /etc/init.d
%define _perldirul	/usr/lib/perl5/5.8.0/i586-linux-thread-multi
%define _perlpdirul	/usr/lib/perl5/5.8.0/i586-linux-thread-multi

# generic
%define _configdir	/var/imap
%define _partitiondir	/var/spool/imap
%define _sievedir	/usr/sieve
%define _cyrususer	cyrus
%define _cyrusgroup	mail

%define _name		cyrus-imapd
%define _version	2.1.10
%define _destdir	%{_tmppath}/%{_name}-%{_version}

#
# Cyrus imapd
#
Summary:	Cyrus imapd
Name:		%{_name}
Version:	%{_version}
Release:	8
Copyright:	CMU public license
Group:		Applications
URL:		http://asg.web.cmu.edu/cyrus/imapd
Source0:	ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/%{_name}-%{_version}.tar.gz
Source1:	%{_name}-%{_version}-init
Patch0:		%{_name}-%{_version}-linux.patch
Patch1:		%{_name}-%{_version}-drac.patch
Patch2:		%{_name}-%{_version}-security.patch
Distribution:	Caldera, Inc.
Vendor:		Caldera, Inc. 
Packager:	Kurt Hutchison <kurth@sco.com>
BuildRoot: 	%{_destdir}
Requires:	cyrus-sasl2 >= 2.1.9
Conflicts:	imap, imap-devel
Exclusivearch:	i586

%Description
IMAP (Internet Message Access Protocol) is an Internet standards-track
protocol for accessing messages (mail, bboards, news, etc).  The Cyrus IMAP
server differs from other IMAP server implementations in that it is generally
intended to be run on sealed servers, where normal users are not permitted to
log in.  The mailbox database is stored in parts of the filesystem that are
private to the Cyrus IMAP system.  All user access to mail is through the IMAP,
POP3, or KPOP protocols. 

The private mailbox database design gives the server large advantages in
efficiency, scalability, and administratability.  Multiple concurrent
read/write connections to the same mailbox are permitted.  The server supports
access control lists on mailboxes and storage quotas on mailbox hierarchies. 

The Cyrus project is the implementation of IMAP servers by the Carnegie Mellon
University Computing Services Department.


%Prep
if %{OpenLinux}
then
	echo OpenLinux Build begun
else
	echo UnitedLinux Build begun
fi
rm -fr %{_destdir}
%setup
%patch0 -p1
%patch1 -p0
%patch2 -p1

%Build
# PLATFORM
if %{OpenLinux}
then
	manprefix=%{_manprefixol}
else
	manprefix=%{_manprefixul}
fi
# rm aclocal.m4 configure
# sh SMakefile
./configure \
	--with-com_err=yes \
	--with-sasl=/usr/cyrus-sasl2 \
        --with-sasl-dir=/usr/cyrus-sasl2/lib/sasl \
        --with-sasl-inc=/usr/cyrus-sasl2/include \
	--with-openssl=/usr/lib \
	--with-perl=perl \
	--prefix=%{_prefix} \
	--mandir=$manprefix \
	--with-ucdsnmp=no \
	--with-drac=/usr/lib
	
make depend
make all CFLAGS='-DDRAC_AUTH=1'

%Install
[ -d %{_destdir} ] || mkdir -p %{_destdir}

# PLATFORM INSTALLDIRS set only on ul
if %{OpenLinux}
then
	make DESTDIR=%{_destdir} install
	svidir=%{_svidirol}
	perldir=%{_perldirol}
	perlpdir=%{_perlpdirol}
else
	make DESTDIR=%{_destdir} INSTALLDIRS=perl install
	svidir=%{_svidirul}
	perldir=%{_perldirul}
	perlpdir=%{_perlpdirul}
fi

# we need the mkimap tool for postinstall
install -m 755 tools/mkimap %{_destdir}%{_prefix}/bin/mkimap

# install the configuration files
install -d %{_destdir}/etc
install -m 644 master/conf/normal.conf %{_destdir}/etc/cyrus.conf
install -m 644 master/conf/imapd.conf %{_destdir}/etc/imapd.conf

#install the pam files
install -d %{_destdir}/etc/pam.d
install -m 644 master/conf/pam.conf %{_destdir}/etc/pam.d/imap
install -m 644 master/conf/pam.conf %{_destdir}/etc/pam.d/pop
install -m 644 master/conf/pam.conf %{_destdir}/etc/pam.d/sieve

# PLATFORM make them both so the %Files area is happy.
install -d %{_destdir}%{_svidirol}
install -d %{_destdir}%{_svidirul}
install -m755 %{SOURCE1} %{_destdir}$svidir/cyrus

#install documentation not covered in man pages
docdir=%{_destdir}%{_defaultdocdir}/%{_name}-%{_version}
install -d $docdir

if %{NotOpenLinux}
then
	# fixup perl directory location on ul, this could be a patch but this is way easier.
	OLD=%{_destdir}/usr/lib/perl5
	OLD2=$OLD/5.6.0/i386-linux
	NEW=%{_destdir}%{_perldirul}
	mkdir -p $NEW
	mv $OLD2/Cyrus $NEW
	mv $OLD2/auto $NEW
	mv $OLD2/perllocal.pod $NEW
	rm -fr $OLD/5.6.0
fi

# make perllocal.pod append to the system one, save it elsewhere until install
mv %{_destdir}$perldir/perllocal.pod %{_destdir}$perlpdir/Cyrus/perllocal.pod

exit 0

%Pre
# PLATFORM
if %{OpenLinux}
then
	svidir=%{_svidirol}
else
	svidir=%{_svidirul}
fi

if [ -x $svidir/cyrus ]
then
	$svidir/cyrus stop
fi
exit 0

%Post
# PLATFORM
if %{OpenLinux}
then
	svidir=%{_svidirol}
	perldir=%{_perldirol}
	perlpdir=%{_perlpdirol}
	install=/usr/lib/LSB/init-install
else
	svidir=%{_svidirul}
	perldir=%{_perldirul}
	perlpdir=%{_perlpdirul}
	install=/usr/lib/lsb/install_initd
fi

# not in-place-upgrade
if [ $1 = 1 ]
then
	$install cyrus

	# currently, a "mail" group already exists on LTP-- but will
	# need to add code to check and add "mail" group if needed

	# add the cyrus user

	newUid=40
	while [ `grep ^%{_cyrususer}: /etc/passwd | wc -l` = 0 ] && [ $newUid -lt 100 ]
	do
	   /usr/sbin/useradd \
	       -c "Cyrus IMAP user" -f -1 -g %{_cyrusgroup} \
	       -u $newUid %{_cyrususer} ||:
	   newUid=$((newUid + 1))
	done
	if [ `grep ^%{_cyrususer}: /etc/passwd | wc -l` = 0 ]; then
	    echo "Cyrus IMAPD preinstall: Failed to add user %{_cyrususer}"
	    exit 1
	fi

	# add syslog logging
	echo "local6.*						/var/log/imapd" >> /etc/syslog.conf
	touch /var/log/imapd
	chmod 600 /var/log/imapd
	kill -SIGHUP `pidof syslogd`

	cat $perlpdir/Cyrus/perllocal.pod >> $perldir/perllocal.pod
else
	# change the sasl_pwcheck_method variable in /etc/imapd.conf
	sed -e 's/^sasl_pwcheck_method.*/sasl_pwcheck_method: saslauthd/' < /etc/imapd.conf > /tmp/tmp$$
	cp /tmp/tmp$$ /etc/imapd.conf
	rm -f /tmp/tmp$$
fi

# can we let the rpm do this instead?  but no cyrus user/group exists at that
# time?
# create the configdirectory
[ ! -d %{_configdir} ] && mkdir %{_configdir}
chown %{_cyrususer} %{_configdir}
chgrp %{_cyrusgroup} %{_configdir}
chmod 750 %{_configdir}

# create the partition directory
[ ! -d %{_partitiondir} ] && mkdir %{_partitiondir}
chown %{_cyrususer} %{_partitiondir}
chgrp %{_cyrusgroup} %{_partitiondir}
chmod 750 %{_partitiondir}

# create the sieve directory
[ ! -d %{_sievedir} ] && mkdir %{_sievedir}
chown %{_cyrususer} %{_sievedir}
chgrp %{_cyrusgroup} %{_sievedir}
chmod 750 %{_sievedir}

# use the mkimap script to create the rest
su -c %{_prefix}/bin/mkimap cyrus

# OpenUnix does not use Linux filesystems, so running chattr on
# an OpenUnix/LKP installation will cause lots of ugly error 
# messages...  If we're on OpenUnix, don't run these commands.
if [ ! -e /unixware/bin/sh ]; then
   # set the user, quota, and partition directories to update synchronously--
   # this is necessary for linux systems using ext2 filesystems and failure
   # to do so may lead to data corruption and/or loss of mail after a system
   # crash
   chattr -R +S %{_configdir}/user
   chattr -R +S %{_configdir}/quota
   chattr -R +S %{_partitiondir}
   # also set the queue directory of the mail daemon to update synchronously
   # must know the MTA for that
   # chattr -R ???
fi

# add /etc/services entries
grep -q "^pop3[ 	]*110/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "pop3		110/tcp" >>/etc/services
fi
grep -q "^imap[ 	]*143/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "imap		143/tcp" >>/etc/services
fi
grep -q "^imsp[ 	]*406/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "imsp		406/tcp" >>/etc/services
fi
# this is in the doc-- but we don't need it do we?
#grep -q "^acap[ 	]*674/tcp" /etc/services
#if [ $? -eq 1 ]
#then
#	echo "acap		674/tcp" >>/etc/services
#fi
grep -q "^imaps[ 	]*993/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "imaps		993/tcp" >>/etc/services
fi
grep -q "^pop3s[ 	]*995/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "pop3s		995/tcp" >>/etc/services
fi
grep -q "^kpop[ 	]*1109/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "kpop		1109/tcp" >>/etc/services
fi
grep -q "^sieve[ 	]*2000/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "sieve		2000/tcp" >>/etc/services
fi
grep -q "^lmtp[ 	]*2003/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "lmtp		2003/tcp" >>/etc/services
fi
grep -q "^fud[ 	]*4201/tcp" /etc/services
if [ $? -eq 1 ]
then
	echo "fud		4201/tcp" >>/etc/services
fi

if [ $1 = 1 ]
then
	# reinitialize syslogd
	kill -SIGHUP `pidof syslogd`

	# PLATFORM
	if %{OpenLinux}
	then
	# set up a sysconfig file 
		cat << EOF > /etc/sysconfig/daemons/cyrus
IDENT=cyrus
DESCRIPTIVE="Cyrus IMAP Server"
ONBOOT="yes"
EOF
	fi
fi

# start the master daemon
$svidir/cyrus start

%Preun
# PLATFORM
if %{OpenLinux}
then
	svidir=%{_svidirol}
	remove=/usr/lib/LSB/init-remove
else
	svidir=%{_svidirul}
	remove=/usr/lib/lsb/remove_initd
fi

if [ $1 = 0 ]
then

	# shut down master daemon
	$svidir/cyrus stop >/dev/null

	# don't remove the cyrus user, we keep the uid forever
	# /usr/sbin/userdel cyrus

	$remove cyrus
fi

%Postun

if [ $1 = 0 ]
then
	# remove syslog logging
	if [ -f /etc/syslog.conf ]
	then
		grep -q "^local.*/var/log/imapd" /etc/syslog.conf
		if [ $? -eq 0 ]
		then
			grep -v "^local.*/var/log/imapd" /etc/syslog.conf >/tmp/syslog.restore
			cp /tmp/syslog.restore /etc/syslog.conf
			rm -f /tmp/syslog.restore
		fi
	fi
	rm -f /var/log/imapd

	# reinitialize syslogd
	kill -SIGHUP `pidof syslogd`


	# don't remove anything,
	# but you can remove these if you want to really blow everything away.
	# rm -rf %{_configdir}
	# rm -rf %{_partitiondir}
	# rm -rf %{_sievedir}

	# don't need to chattr -S the cyrus directories since they are removed,
	# but will need to chattr -S the postfix queue directories when we
	# add the chattr +S of them to the spec file?

	# not bothering to remove /etc/services entries for now
fi

%Clean
rm -fr %{_destdir}

%Files
%config(noreplace) /etc/cyrus.conf
%config(noreplace) /etc/imapd.conf
%config /etc/pam.d/imap
%config /etc/pam.d/pop
%config /etc/pam.d/sieve
/etc/init.d
/etc/rc.d
%doc COPYRIGHT doc/*.html
/usr/cyrus
/usr/include/cyrus
/usr/bin/*
/usr/lib/*
%{_mandir}
