%define Apxs			%(type -path apxs || echo "/usr/sbin/apxs")
%define ApacheDataDir		%(%{Apxs} -q DATADIR)
%define ApacheSysconfDir	%(%{Apxs} -q SYSCONFDIR)
%define ApacheGroup		%(%{Apxs} -q CONF_GROUP)
%define ApacheUser		%(%{Apxs} -q CONF_USER)

%define HordeDocroot		%{ApacheDataDir}/html/horde
%define	HordeLibexecDir		/usr/lib/horde
%define PhpLibDir		%{ApacheDataDir}/phplib

Name        	: horde
Version     	: 1.2.7
Release     	: 1
Group       	: Server/WWW

Summary     	: Horde is a php framework for several web-based applications.
Summary(de) 	: Horde ist ein PHP-Framework fr Web-basierte Anwendungen.
Summary(es) 	: Horde es un entorno en php para varias aplicaciones web.
Summary(fr) 	: Horde est un cadre php pour plusieurs applications web.
Summary(it) 	: Horde  un framework php per varie applicazioni basate sul web.
Summary(pt) 	: Horde  uma biblioteca php para vrias aplicaes web.
Summary(pt_BR) 	: Horde  uma biblioteca php para vrias aplicaes web.

Copyright   	: GPL
Packager    	: Holger Sickenberg <hs@caldera.de>
URL         	: http://www.horde.org/

Provides    	: horde
Requires    	: apache php mysql

BuildRoot   	: /tmp/%{Name}-%{Version}

Source0: ftp://ftp.horde.org/horde.org/imp/tarballs/%{Name}-%{Version}.tar.gz
Source1: horde.setup-1.1
Source2: horde.conf-apache-1.2
Source3: horde.README.html
Patch0: horde-mysql.patch
Patch1: horde-dbpasswd.patch
Patch2: horde-database.patch


%Description
The Horde framework makes common useful PHP routines available to Php
applications based on the framework, such as IMP, Kronolith and Turba.

%Description -l de
Das Framework Horde stellt allgemein bliche PHP-Routinen anderen auf dem
Framework basierenden PHP-Anwendungen zur Verfgung (z.B. IMP, Kronolith und
Turba).

%Description -l es
El entorno Horde hace que rutinas tiles y comunes en PHP estn disponibles
para aplicaciones en PHP basadas en este entorno, tales como IMP, Kronolith y
Turba.

%Description -l fr
Le cadre Horde met  votre disposition les routines communes de PHP
servant aux applications PHP bases sur ce cadre, telles que IMP,
Kronolith et Turba.

%Description -l it
L'infrastruttura Horde rende alcune procedure comuni ed utili di PHP
disponibili per applicazioni PHP basate su questa infrastruttura, come ad
esempio IMP, Kronolith e Turba.

%Description -l pt
O conjunto de ferramentas Horde fornece rotinas PHP uteis s aplicaes
PHP que nele se baseram, tais como o IMP, o Kronolith e o Turba.

%Description -l pt_BR
O conjunto de ferramentas Horde fornece rotinas PHP uteis s aplicaes
PHP que nele se baseram, tais como o IMP, o Kronolith e o Turba.

%Prep
%setup -n %{Name}-%{Version} -q
%patch0 -p1
%patch1 -p1
%patch2 -p1


%Build
mv config/horde.php3.dist config/horde.php3
perl -pi -e "s/^(\\s*\\\$default->problem_reporting\\s*=\\s*)false;/\$1true;/" \
	config/horde.php3


%Install

DROPDIR=%{ApacheSysconfDir}/modules

%{mkDESTDIR}
install -d $DESTDIR/$DROPDIR
install -d $DESTDIR%{HordeDocroot}
install -d $DESTDIR%{PhpLibDir}
install -d $DESTDIR%{HordeLibexecDir}

HORDE_SETUP="$DESTDIR%{HordeLibexecDir}/horde.setup"
cp %{SOURCE1} $HORDE_SETUP
%{fixUP} -T $HORDE_SETUP -e 's:\@HordeDocroot\@:%{HordeDocroot}:g'
%{fixUP} -T $HORDE_SETUP -e 's:\@HordeLibexecDir\@:%{HordeLibexecDir}:g'

HORDE_CONF="$DESTDIR/$DROPDIR/mod_php4_horde.conf"
install -m 0644 %{SOURCE2} $HORDE_CONF
%{fixUP} -T $HORDE_CONF -e 's:\@HordeDocroot\@:%{HordeDocroot}:g'
%{fixUP} -T $HORDE_CONF -e 's:\@PhpLibDir\@:%{PhpLibDir}:g'

HORDE_README="$DESTDIR%{HordeDocroot}/../horde.README.html"
install -m 0644 %{SOURCE3} $HORDE_README
%{fixUP} -T $HORDE_README -e \
            "s:\@HordeApacheConf\@:$DROPDIR/mod_php4_horde.conf:g"
%{fixUP} -T $HORDE_README -e \
            's:\@HordeSetup\@:%{HordeLibexecDir}/horde.setup:g'
%{fixUP} -T $HORDE_README -e \ 's:\@SVCONFDIR\@:%{SVIcdir}:g'
%{fixUP} -T $HORDE_README -e \ 's:\@SVINITDIR\@:%{SVIdir}:g'
# ughh...
install -m 0644 $HORDE_README ./README.OpenLinux.html

cp -a scripts/* $DESTDIR%{HordeLibexecDir}/
cp -a install.sh $DESTDIR%{HordeLibexecDir}/
cp -a secure.sh $DESTDIR%{HordeLibexecDir}/
cp phplib/*.inc $DESTDIR%{PhpLibDir}/
cp phplib/*.php3 $DESTDIR%{PhpLibDir}/
cp phplib/*.ihtml $DESTDIR%{PhpLibDir}/
cp phplib/README README.phplib

cp -a * $DESTDIR%{HordeDocroot}
%{fixManPages}


%Clean
%{rmDESTDIR}


%Pre

%Post
if [ -e %{HordeDocroot}/imp/config/defaults.php3 ]; then
	DB_USERNAME=`/usr/bin/perl -p -e "/^\\\\s*\\\\\\$default->db_user_name\\\\s*=\\\\s*'(.*?)';/ && print \\$1; \\$_='';" \
		%{HordeDocroot}/imp/config/defaults.php3`
	DB_PASSWORD=`/usr/bin/perl -p -e "/^\\\\s*\\\\\\$default->db_password\\\\s*=\\\\s*'(.*?)';/ && print \\$1; \\$_='';" \
		%{HordeDocroot}/imp/config/defaults.php3`
	/usr/bin/perl -pi -e  "s~^(\\s*var\\s*\\\$User\\s*=\\s*)'hordemgr';~\$1'$DB_USERNAME';~;" \
		-e "s~^(\\s*var\\s*\\\$Password\\s*=\\s*)'hordemgr';~\$1'$DB_PASSWORD';~;" \
		%{PhpLibDir}/local.inc
fi

%PreUn

%Files
%defattr(-,root,root)

%attr(-,root,root) %doc COPYING README docs README.phplib README.OpenLinux.html

%dir %attr(0750,root,%{ApacheGroup}) %{HordeDocroot}/config
%dir %{HordeDocroot}/lib
%dir %{HordeDocroot}
%dir %attr(0750,root,%{ApacheGroup}) %{PhpLibDir}/
%dir %{HordeLibexecDir}/

%attr(0444,root,root) %{HordeDocroot}/lib/horde.lib
%attr(0444,root,root) %{HordeDocroot}/lib/mime.lib

%config %{ApacheSysconfDir}/modules/*.conf
%{HordeDocroot}/graphics
%{HordeDocroot}/locale
%{HordeDocroot}/templates

%attr(0000,root,root) %{HordeDocroot}/setup.php3
%attr(0000,root,root) %{HordeDocroot}/test.php3
%{HordeDocroot}/../horde.README.html
%{HordeDocroot}/help.php3
%{HordeDocroot}/index.php3
%{HordeDocroot}/login.php3
%{HordeDocroot}/logo.php3
%{HordeDocroot}/menu.php3
%{HordeDocroot}/modules.php3
%{HordeDocroot}/problem.php3
%{HordeDocroot}/signup.php3
%{HordeDocroot}/status.php3
%{HordeDocroot}/lib/js
%{HordeDocroot}/lib/version.php

%attr(0444,root,root) %config(noreplace) %{HordeDocroot}/config/horde.php3
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/html.php3
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/MOTD.html
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/menu.txt
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/mime.php3
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/header.txt
%attr(0640,root,%{ApacheGroup}) %config(noreplace) %{HordeDocroot}/config/lang.php3

%attr(0640,root,%{ApacheGroup}) %{PhpLibDir}/*
%{HordeLibexecDir}/*


%ChangeLog
* Mon Jan 01 1998 ...
Template Version: 1.31

$Id: horde.spec,v 1.16 2001/11/14 13:41:44 hs Exp $
