%define ispelldir %(if [ "%{_mandir}" = "/usr/share/man" ]; then echo "/usr/share/ispell"; else echo "/usr/lib/ispell"; fi)

Name        	: ispell
Version     	: 3.1.20
Release     	: 14MR
Group       	: Textprocessing/Tools
Summary     	: An interactive spelling checker.
Summary(de) 	: Ein interaktive Korrekturhilfe.
Summary(es) 	: Un comprobador de ortografa interactivo.
Summary(fr) 	: Un vrificateur orthographique interactif.
Summary(it) 	: Un correttore ortografico interattivo.
Summary(pt) 	: Um verificador ortogrfico interactivo.

Copyright   	: Pace Willisson, Geoff Kuenning
Packager    	: Joel Smith <jsmith@caldera.com>
Icon        	: Caldera.gif
URL         	: http://ficus-www.cs.ucla.edu/ficus-members/geoff/ispell.html


BuildRoot   	: /tmp/%{Name}-%{Version}

Source0		: ftp://ftp.gnu.org/pub/gnu/ispell/%{Name}-%{Version}.tar.gz
Source1		: %{Name}-%{Version}-local.h
Source2		: ftp://ftp.informatik.uni-kiel.de/pub/kiel/dicts/hk2-deutsch.tar.gz
Source3		: ftp://ftp.robot.ireq.ca/pub/ispell/francais-IREQ-1.4.tar.gz
Source4		: ftp://ftp.fi.upm.es/pub/unix/espa~nol-1.6.tar.gz
Source5		: ftp://ftp.cs.auc.dk/pub/packages/dkispell/dkispell-words-tar.Z
Source6		: http://www.suse.de/~bjacke/igerman98/dict/igerman98-20001109.tar.bz2
Source7		: ftp://ftp.mrg.dist.unige.it/pub/mrg-usr/marco/ispell.tar
Source8		: ispell-polish.tar.gz

Source14	: ispell-espa~nol-1.6.words+.gz

Patch0		: %{Name}-%{Version}-info.patch
Patch1		: %{Name}-%{Version}-languages.patch
Patch2		: %{Name}-%{Version}-glibc21.patch
Patch3		: %{Name}-%{Version}-glibc22.patch
Patch4		: ispell-tmpfile.patch


%Package danish
Group       	: Textprocessing/Tools
Icon        	: Caldera-dk.gif
Summary     	: Danish ispell dictionaries.
Summary(de) 	: Dnische ispell Wrterbcher.
Summary(es) 	: Diccionarios ispell daneses.
Summary(fr) 	: Dictionnaire ispell danois.
Summary(it) 	: Dizionari danesi per ispell.
Summary(pt) 	: Dicionrio para o ispell em dinamarqus.


%Package english
Group       	: Textprocessing/Tools
Icon        	: Caldera-en.gif
Summary     	: English ispell dictionaries.
Summary(de) 	: Englisches ispell Wrterbuch.
Summary(es) 	: Diccionarios ispell ingleses.
Summary(fr) 	: Dictionnaire ispell anglais.
Summary(it) 	: Dizionari inglesi per ispell.
Summary(pt) 	: Dicionrio para o ispell em ingls.


%Package french
Group       	: Textprocessing/Tools
Icon        	: Caldera-fr.gif
Summary     	: French ispell dictionary.
Summary(de) 	: Franzsisches ispell Wrterbuch.
Summary(es) 	: Diccionarios ispell franceses.
Summary(fr) 	: Dictionnaire ispell franais.
Summary(it) 	: Dizionari francesi per ispell.
Summary(pt) 	: Dicionrio para o ispell em francs.


%Package german
Group       	: Textprocessing/Tools
Icon        	: Caldera-de.gif
Summary     	: German ispell dictionary.
Summary(de) 	: Deutsches ispell Wrterbuch.
Summary(es) 	: Diccionarios ispell alemanes.
Summary(fr) 	: Dictionnaire ispell allemand.
Summary(it) 	: Dizionari tedeschi per ispell.
Summary(pt) 	: Dicionrio para o ispell em alemo.


%Package spanish
Group       	: Textprocessing/Tools
Icon        	: Caldera-it.gif
Summary     	: Spanish ispell dictionaries.
Summary(de) 	: Spanische ispell Wrterbcher.
Summary(es) 	: Diccionarios ispell espaoles.
Summary(fr) 	: Dictionnaire ispell espagnol.
Summary(it) 	: Dizionari spagnoli per ispell.
Summary(pt) 	: Dicionrio para o ispell em espanhol.

%Package italian
Group       	: Textprocessing/Tools
Icon        	: Caldera-es.gif
Summary     	: Italian ispell dictionaries.
Summary(de) 	: Italienisces ispell Wrterbuch".
Summary(es) 	: Diccionarios ispell italianos.
Summary(fr) 	: Dictionnaire ispell italien.
Summary(it) 	: Dizionari italiani per ispell.
Summary(pt) 	: Dicionrio para o ispell em italiano.

%Package polish
Group       	: Textprocessing/Tools
Icon        	: Caldera-pl.gif
Summary     	: Polish ispell dictionaries.
Summary(pl) 	: Polish ispell dictionaries.

%Description
'ispell' is the GNU interactive spelling checker. You can use it to
interactively check the spelling of text files.

%Description -l pt_BR
O 'ispell'  o verificador ortogrfico interativo da GNU. O usurio pode
us-lo para verificar interativamente a correo ortogrfica de arquivos de
texto.

%Description -l de
'ispell' ist das GNU interactive spelling Programm. Sie knnen es zum
interaktiven berprfen der Rechtschreibung von Texten verwenden.

%Description -l es
ispell es el corrector ortogrfico interactivo de GNU. Puede usarlo para
comprobar la ortografa de ficheros de texto.

%Description -l fr
'ispell' est le vrificateur orthographique interactif de GNU. Vous
pouvez l'utiliser pour vrifier de faon interactive l'orthographe de
vos fichiers de texte.

%Description -l it
"spell"  il correttore ortografico interattivo GNU. E' utile per
correggere in maniera interattiva l'ortografia dei file di testo.

%Description -l pt
O 'ispell'  o verificador ortogrfico interactivo da GNU. O utilizador pode
us-lo para verificar interactivamente a correco ortogrfica de ficheiros de
texto.

%Description danish
This package contains the Danish ispell dictionaries.

%Description -l pt_BR danish
Este pacote contem os dicionrios de dinamarqus do ispell.

%Description -l de danish
Dieses Paket enthlt die dnischen ispell Wrterbcher.

%Description -l es danish
Este paquete contiene el diccionario ispell en dans.

%Description -l fr danish
Ce paquetage contient les dictionnaires ispell danois.

%Description -l it danish
Questo pacchetto contiene i dizionari danesi per ispell.

%Description -l pt danish
Este pacote contm os dicionrios de dinamarqus do ispell.

%Description english
This package contains the English ispell dictionaries.

%Description -l pt_BR english
Este pacote contem os dicionrios de ingls do ispell.

%Description -l de english
Dieses Paket enthlt die englischen ispell Wrterbcher.

%Description -l es english
Este paquete contiene el diccionario ispell en ingls.

%Description -l fr english
Ce paquetage contient les dictionnaires ispell anglais.

%Description -l it english
Questo pacchetto contiene i dizionari inglesi per ispell.

%Description -l pt english
Este pacote contm os dicionrios de ingls do ispell.

%Description french
This package contains the French ispell dictionaries.

%Description -l pt_BR french
Este pacote contem os dicionrios de francs do ispell.

%Description -l de french
Diese Paket enthlt die franzsischen ispell Wrterbcher.

%Description -l es french
Este paquete contiene el diccionario ispell en francs.

%Description -l fr french
Ce paquetage contient les dictionnaires ispell franais.

%Description -l it french
Questo pacchetto contiene i dizionari francesi per ispell.

%Description -l pt french
Este pacote contm os dicionrios de francs do ispell.

%Description german
This package contains the German ispell dictionaries.

%Description -l pt_BR german
Este pacote contem os dicionrios de alemo do ispell.

%Description -l de german
Dieses Paket enthlt die deutschen ispell Wrterbcher.

%Description -l es german
Este paquete contiene el diccionario ispell en alemn.

%Description -l fr german
Ce paquetage contient les dictionnaires ispell allemands.

%Description -l it german
Questo pacchetto contiene i dizionari tedeschi per ispell.

%Description -l pt german
Este pacote contm os dicionrios de alemo do ispell.

%Description spanish
This package contains the Spanish ispell dictionaries.

%Description -l pt_BR spanish
Este pacote contem os dicionrios de espanhol do ispell.

%Description -l de spanish
Dieses Paket enthlt die spanischen ispell Wrterbcher.

%Description -l es spanish
Este paquete contiene el diccionario ispell en espaol.

%Description -l fr spanish
Ce paquetage contient les dictionnaires ispell espagnols.

%Description -l it spanish
Questo pacchetto contiene i dizionari spagnoli per ispell.

%Description -l pt spanish
Este pacote contm os dicionrios de espanhol do ispell.

%Description italian
This package contains the Italian ispell dictionaries.

%Description -l pt_BR italian
Este pacote contem os dicionrios de italiano do ispell.

%Description -l de italian
Dieses Paket enthlt die italienischen ispell Wrterbcher.

%Description -l es italian
Este paquete contiene el diccionario ispell en italiano.

%Description -l fr italian
Ce paquetage contient les dictionnaires ispell italiens.

%Description -l it italian
Questo pacchetto contiene i dizionari italiani per ispell.

%Description -l pt italian
Este pacote contm os dicionrios de italiano do ispell.

%Description polish
This package contains the English ispell dictionaries.

%Description -l pl polish
This package contains the English ispell dictionaries.


%Prep
%setup -n ispell-3.1

cp %{SOURCE1} local.h
echo '#define CFLAGS "'$RPM_OPT_FLAGS'"' >> local.h
echo '#define LIBDIR "%{ispelldir}"' >> local.h
echo '#define TEXINFODIR "%{_infodir}"' >> local.h
echo '#define MAN1DIR "%{_mandir}/%{manEN}/man1"' >> local.h
echo '#define MAN4DIR "%{_mandir}/%{manEN}/man4"' >> local.h

  mkdir -p languages/{deutsch-hk,deutsch-hk2,italian,francais-IREQ,polish}
  tar xvvzfC %{SOURCE2} languages/deutsch-hk
  /bin/bzcat %{SOURCE6} | tar xvvfC - languages/deutsch-hk2
  tar xvvzfC %{SOURCE3} languages/francais-IREQ
  tar xvvzfC %{SOURCE4} languages
  tar xvvzfC %{SOURCE5} languages/dansk
  tar xvvfC  %{SOURCE7} languages/italian
  tar xvvzfC %{SOURCE8} languages/polish

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p0
%patch4 -p1

  cd languages

    if [ -d deutsch-hk ]&&[ -d deutsch ]; then
      cd deutsch-hk
      cp deutsch.aff ../deutsch/deutsch.7bit
      cp *.txt ../deutsch
      cd ..
    fi

    if [ -d espa~nol-1.6 ]; then
      cd espa~nol-1.6
      if [ -n "$COL_DONT_USE_PREBUILD" ]; then
        rm -f espa~nol.words+
      else
	# Question: should we spare the time for `munchlist'?
	zcat %{SOURCE14} > espa~nol.words+
      fi
      cd ..
    fi

    if [ -d dansk ]; then
      cd dansk
      perl -pi \
	  -e 's:\t\-?EDE:/a:; s:\tNAVN:/d:; s:\tEN:/A:;' \
	  -e 's:[ \t]+$::g' danish.med
      cd ..
    fi

    if [ -d polish ]; then
	cd polish
	cd ..
    fi

  cd ..

  %{IsNotRoot} || {
    h=h; chown -h 1.1 . 2>/dev/null || h=
    chown -R$h root.root .
  }


%Build
PATH=`pwd`:../..:$PATH; export PATH
TMPDIR=/tmp; export TMPDIR
make
    cd languages
    if [ -d deutsch-hk2 ]; then
       cd deutsch-hk2
       dirname=`ls -d igerman*`
       cd $dirname
       make
       mv german.aff ../deutsch.aff
       mv german.hash ../deutsch.hash
       cd ../..
    fi
    if [ -d italian ]; then
       cd italian/ispell
       TMPDIR=/tmp make clean
       TMPDIR=/tmp make
       mv italian.aff italian.hash ..
       cd ../..
    fi
    cd ..

%Install
%{mkDESTDIR}
mkdir -p $DESTDIR/usr/bin
mkdir -p $DESTDIR/%{ispelldir}
mkdir -p $DESTDIR/%{_infodir}
mkdir -p $DESTDIR/%{_mandir}/%{manEN}/man{1,4}

# Use $DESTDIR in `config.sh'
[ -f config.sh-build ] || {
  cp -p config.sh config.sh-build
  %{fixUP} -vbT config.sh -e 's:(DIR='"'"')/:$1'$DESTDIR'/:'
}

make install

%{fixUP} -vT $DESTDIR/usr/bin -e 's/^: Use/#!/ if ($. == 1);'

# Fix permissions and file names
mv $DESTDIR/%{_infodir}/ispell $DESTDIR/%{_infodir}/ispell.info
chmod -x $DESTDIR/%{ispelldir}/francais*

# Create synonyms of the man pages for every command and library
for i in buildhash findaffix munchlist tryaffix; do
  ln -sf ispell.1 $DESTDIR/%{_mandir}/%{manEN}/man1/$i.1
done
ln -sf sq.1 $DESTDIR/%{_mandir}/%{manEN}/man1/unsq.1

# Move the man pages of volume 4 to volume 5
mv $DESTDIR/%{_mandir}/%{manEN}/man4 $DESTDIR/%{_mandir}/%{manEN}/man5
for i in $DESTDIR/%{_mandir}/%{manEN}/man5/*; do
  mv $i ${i%.4}.5
done
%{fixUP} -vT $DESTDIR/%{_mandir}/%{manEN}/man1/ispell.1 -e 's/\(4L\)/\(5\)/g;'
%{fixUP} -vT $DESTDIR/%{_mandir}/%{manEN}/man5 -e '
   s/4($| local)/5$1/ + s/ok(spell)/i$1/g + s/(spell ?\()4/${1}5/g'

    cd languages
    if [ -d deutsch-hk2 ]; then
     cd deutsch-hk2
     mv deutsch.* $DESTDIR/%{ispelldir}
     cd ..
    fi
    if [ -d italian ]; then
     cd italian
     mv italian.* $DESTDIR/%{ispelldir}
     cd ..
    fi
    if [ -d polish ]; then
     cd polish
     mv polish.* $DESTDIR/%{ispelldir}
     cd ..
    fi
    cd ..

# Fix man and info pages
%{fixInfoPages}
%{fixManPages}

# Extract 'Copyright'
%{mkCopyright} ispell.c COPYING


%Clean
%{rmDESTDIR}


%Post
lisa --info install ispell --section "Miscellaneous:"


%PreUn
lisa --info remove ispell $1


%Files
%doc COPYING README WISHES Contributors

/usr/bin/buildhash
/usr/bin/findaffix
/usr/bin/icombine
/usr/bin/ijoin
/usr/bin/ispell
/usr/bin/munchlist
/usr/bin/sq
/usr/bin/tryaffix
/usr/bin/unsq

%dir %{ispelldir}

%{_infodir}/ispell.info*

%{_mandir}/%{manEN}/man1/*.1*
%{_mandir}/%{manEN}/man5/*.5*


%Files danish
%{ispelldir}/dansk*


%Files english
%{ispelldir}/american*
%{ispelldir}/british*
%{ispelldir}/english*


%Files french
%{ispelldir}/francais*


%Files german
%{ispelldir}/deutsch*


%Files spanish
%{ispelldir}/espa~nol*


%Files italian
%{ispelldir}/italian*


%Files polish
%{ispelldir}/polish*


%ChangeLog
* Mon Jan 01 1997 ...
$Id: ispell.spec,v 1.11 2001/11/12 13:35:40 coolo Exp $

Todo:
 - check quality of supplied dictionaries (including English)
 - add Finnish, Italian, Portuguese, Dutch, Swedish, Russian, ...
