<?php
/*
 * Copyright (C) 2002 Caldera International, Inc.  All Rights Reserved.
 */

//  include_once IMP_BASE . '/lib/scomsg.php';

function __scomsg_getmail() {
	global $imp;

	$user = $imp['user'];
	$msgconf = '/etc/opt/lsb-sco.com/msg/msg.conf';

	// Get system configuration data
	$fd = fopen($msgconf, "r");
	$data = explode("\n", fread($fd, filesize($msgconf)));
	fclose($fd);
	while($data) {
		$tmp = array_pop($data);
		if (! $tmp) { continue; }
		list($attr, $value) = split(":", $tmp, 2);
		switch($attr) {
			case "LDAPHOST": 
				$LDAPHost = $value;
				break;
			case "LDAPPORT": 
				$LDAPPort = $value;
				break;
			case "LDAPSUFFIX":
				$LDAPSuffix = $value;
				break;
			case "DN":
				$LDAPanonuser = $value;
				break;
			case "PW":
				$LDAPanonpw = $value;
				break;
			default:
				break;
		}
		unset($tmp);
	}

	$ldapServer = $LDAPHost;
	if (isset($LDAPPort)) {
		$ldapServer .= ($LDAPPort) ? ":$LDAPPort" : '';
	}
	$link = ldap_connect($ldapServer);

	if ($link == 0) return false;

	if (ldap_set_option($link, LDAP_OPT_PROTOCOL_VERSION, 3)) {
		$bind = @ldap_bind($link, $LDAPanonuser, $LDAPanonpw);
	}

	if (! $bind) return false;

	unset($bind);

	$attributes = array('cn', 'mail', 'objectclass');
	$result = @ldap_search(
		$link, 
		$LDAPSuffix,
      		'(&(objectclass=msgUser)(uid=' . $user . '))',
		$attributes
	);

	if (! $result) {
		return false;
	}

	$dnid = ldap_first_entry($link, $result);	
	if (! $dnid) {
		// no ldap entry was found for $user
		return false;
	}
	// $dn = ldap_get_dn($link, $dnid);
	// $dn = ldap_explode_dn($dn, 0);
	// $tmp = explode("=", trim($dn[2]));
	// $domain = $tmp[1];

	$tmp = ldap_get_attributes($link, $dnid);
	$mail = $tmp['mail'][0];
	list($shortmail, $domain) = split("@", $mail, 2);

	if ($shortmail) {
        	$imp['scomsg_mail'] = $mail;
	}
	if ($domain) {
		$imp['maildomain'] = $domain;
	}

	return true;
}

__scomsg_getmail();

function __scomsg_expand_fromaddress($imp) {
	$name = $imp['scomsg_mail'];
	return (empty($name) ? $imp['user'] : $name);
}

$conf['hooks']['from'] = '__scomsg_expand_fromaddress';

?>
