#!/bin/bash
#
# Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
#

# this is the common preinstall script shared by both the
# volution manager and graphical install procedures.

# If we're installing on an OpenUnix system w/ LKP, make sure the
# Linux side has an /etc/resolv.conf file (it's not set up by default
# with the OpenUnix LKP installation).

SCRIPTPATH=`dirname $0`

UNITEDLINUX=`$SCRIPTPATH/platform.sh --ul`

if [ "$UNITEDLINUX" -eq 1 ] ; then
	LDAPDIR=/etc/openldap;	
else 
	LDAPDIR=/etc/ldap;	
fi

if [ -e /unixware/etc/resolv.conf ]; then
        if grep ^nameserver /unixware/etc/resolv.conf > /dev/null 2>&1; then
                if [ -e /etc/resolv.conf ] && [ ! -L /etc/resolv.conf ]; then 
			mv /etc/resolv.conf /etc/resolv.conf.dist 
		fi
                ln -s /unixware/etc/resolv.conf /etc/resolv.conf
        fi
fi

# Check whether we have name resolution
#
#if ! host `hostname` > /dev/null 2>&1; then
#        echo "There appears to be a problem with DNS." >&2
#        exit 1
#fi

# Install licensing utilities if necessary
[ -f /etc/brand ] || {
	install -m 711 -o bin -g bin $SCRIPTPATH/brand /etc/brand
}
[ -d /var/netls ] || {
	install -d -m 755 -o bin -g bin /var/netls
}
[ -f /var/netls/licmap.db ] || {
	install -m 644 -o bin -g bin $SCRIPTPATH/licmap.db /var/netls/licmap.db
}

#
# Make sure sendmail is really, really stopped
#
killall -15 sendmail >/dev/null 2>&1
sleep 2
killall -9 sendmail >/dev/null 2>&1
sleep 2

SAVEDIR=/etc/opt/lsb-sco.com/msg/save
# save the ldap config for optional restore later
if [ ! -d $SAVEDIR ]; then
	mkdir -p $SAVEDIR
	[ -f  $LDAPDIR/ldap.conf ] && { 
		cp $LDAPDIR/ldap.conf $SAVEDIR; }
	[ -f  $LDAPDIR/sldap.conf ] && { 
		cp $LDAPDIR/sldap.conf $SAVEDIR; }
	[ -f  /etc/pam_ldap/auth_ldap.conf ] && {
		cp /etc/pam_ldap/auth_ldap.conf $SAVEDIR; }
	[ -f  /etc/sysconfig/daemons/ldap ] && {
		cp /etc/sysconfig/daemons/ldap $SAVEDIR; }
fi
