<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

// Where are we
$WEBROOT = substr($SCRIPT_NAME, 0, strpos($SCRIPT_NAME, '/', 1) + 1);
$HTTPROOT = 'http://' . $SERVER_NAME . ':' . $SERVER_PORT . '/' . $WEBROOT;

// Get the hardcoded values -- prefix may be unset
include($RELATIVE_PATH_PREFIX . './constants.inc');

// Get system configuration data
$fd = fopen($CONFIGFILE, "r");
$data = explode("\n", fread($fd, filesize($CONFIGFILE)));
fclose($fd);
while($data) {
	list($attr, $value) = split(":", array_pop($data), 2);
	switch($attr) {
		case "LDAPHOST": 
			$LDAPHost = $value;
			break;
		case "LDAPPORT": 
			$LDAPPort = $value;
			break;
		case "LDAPSUFFIX":
			$LDAPSuffix = $value;
			break;
		case "DN":
			$LDAPanonuser = $value;
			break;
		case "PW":
			$LDAPanonpw = $value;
			break;
		case "BIN":
			$BINDIR = $value . "/";
			break;
		case "TMP":
			$TMPDIR = $value . "/";
			break;
		case "GUIROOT":
			$GUIROOT = $value . "/";
			break;
		case "DOCROOT":
			$_DOCVIEW_ROOT = $value . "/";
			break;
		case "ADMIN":
			$LDAP_OC_ADMIN = $value;
			break;
		case "USER":
			$LDAP_OC_USER  = $value;
			break;
		case "PRODID":
			$PRODID = $value;
			break;
		case "PRODVER":
			$PRODVER = $value;
			break;
		default:
			break;
	}
}

// Setup Other Vars
$_VERSION_TEXT= strtoupper($PRODID) . " V" . $PRODVER;
$LOGFILE = $TMPDIR . $LOGFILE_NAME;
$EXECCMD = $BINDIR . $EXECCMD_NAME;
$_DOCVIEW_BASE = 'http://' . $SERVER_NAME . ':' . $DOCVIEW_PORT . '/';
$_DOCTYPE = $IE5 . "\n";
$includePath = $GUIROOT;
session_save_path($VMS_SESSION_FILE);

// Load other constants and objects
include $includePath . 'objs/ObjectTable.php';

include $includePath . 'objs/Alias.php';
include $includePath . 'objs/AliasList.php';
include $includePath . 'objs/AliasListUser.php';
include $includePath . 'objs/AliasListMy.php';
include $includePath . 'objs/AliasSelectList.php';
include $includePath . 'objs/Authenticate.php';
include $includePath . 'objs/Browser.php';
include $includePath . 'objs/Command.php';
include $includePath . 'objs/Domain.php';
include $includePath . 'objs/DomainList.php';
include $includePath . 'objs/ErrorStack.php';
include $includePath . 'objs/File.php';
include $includePath . 'objs/FileProgList.php';
include $includePath . 'objs/Help.php';
include $includePath . 'objs/I18N.php';
include $includePath . 'objs/LNav.php';
include $includePath . 'objs/License.php';
include $includePath . 'objs/LicenseList.php';
include $includePath . 'objs/MailAddress.php';
include $includePath . 'objs/MemberList.php';
include $includePath . 'objs/OwnerList.php';
include $includePath . 'objs/RuleList.php';
include $includePath . 'objs/Search.php';
include $includePath . 'objs/Server.php';
include $includePath . 'objs/Service.php';
include $includePath . 'objs/ServiceList.php';
include $includePath . 'objs/Table.php';
include $includePath . 'objs/User.php';
include $includePath . 'objs/UserList.php';
include $includePath . 'objs/UserListQuota.php';
include $includePath . 'objs/UserListUser.php';
include $includePath . 'objs/UserSelectList.php';


// Load message catalogs
$INTL = new I18N();
$LANGPATH = $INTL->getLangPath();
$HELPPATH = $LANGPATH . '/help';

// Detect Browser Capabilities
$browser = new Browser();
$_NN = $browser->getNN();


// If a session does not yet exist for this user, start one
session_start();

// Load the session variables
if (! $PHPSESSID) {
	session_register("session_dn");
	session_register("session_class");
	session_register("session_domain");
	session_register("session_user");
	session_register("session_passwd");
	session_register("session_lang");
	session_register("session_searchObj");
	session_register("session_tableObj");
	session_register("session_serialNum");
	session_register("session_view");
	session_register("session_perms");
	session_register("session_errors");
	session_register("passthru_error");
} else {
	if (! $session_dn)        { session_register("session_dn");        }
	if (! $session_class)     { session_register("session_class");     }
	if (! $session_domain)    { session_register("session_domain");    }
	if (! $session_user)      { session_register("session_user");      }
	if (! $session_passwd)    { session_register("session_passwd");    }
	if (! $session_lang)      { session_register("session_lang");      }
	if (! $session_searchObj) { session_register("session_searchObj"); }
	if (! $session_tableObj)  { session_register("session_tableObj");  }
	if (! $session_serialNum) { session_register("session_serialNum"); }
	if (! $session_view)      { session_register("session_view");      }
	if (! $session_perms)     { session_register("session_perms");     }
	if (! $session_errors)    { session_register("session_errors");    }
	if (! $passthru_error)    { session_register("passthru_error");    }
}

$session_serialNum++;
$session_lang = $INTL->getLang();
if ($session_errors == '') {
	$session_errors = new ErrorStack();
}

// Helper functions

// Inform JavaScript of important variable values
function setJavaScriptVars() {
	global $_NN, $session_domain, $session_user,
		$session_class, $session_lang;

	$_JAVASCRIPT_VARS  = '<script language="JavaScript">';
	$_JAVASCRIPT_VARS .= "var session_domain = '$session_domain';";
	$_JAVASCRIPT_VARS .= "var session_user = '$session_user';";
	$_JAVASCRIPT_VARS .= "var session_class = '$session_class';";
	$_JAVASCRIPT_VARS .= "var session_lang = '$session_lang';";
	if ($_NN) {
		$_JAVASCRIPT_VARS .= 'var _NN = 1;';
	} else { 
		$_JAVASCRIPT_VARS .= 'var _NN = 0;';
	}
	$_JAVASCRIPT_VARS .= '</script>';

	return $_JAVASCRIPT_VARS;
}

function getSerial() {
	global $serial, $session_serialNum;
	if (isset($serial) && $serial != '') {
		return $serial;
	}
	return $session_serialNum;
}

/******************************************************************************
 * toBool()
 *
 * Takes a variable and returns it's boolean equivalent. If the string
 * is "true" (regardless of case) then return is true. Return is false
 * otherwise. The string "true" is always English, not internationalized.
 *
 * Parameters:
 * o $value - string - the string value to convert to boolean value
 * Returns: a boolean
 ******************************************************************************
 */
function toBool($value) {
	if (strcasecmp($value, 'true') == 0) {
		return true;
	}
	return false;
}

function isAdmin() {
	$numArgs = func_num_args();

	switch ($numArgs) {
	  case 0:
		return Authenticate::isAdmin();
		break;
	  case 1:
		$arg1 = func_get_arg(0);
		return Authenticate::isAdmin($arg1);
		break;
	  default:
		return false;
		break;
	} 
}

/******************************************************************************
 * debug()
 *
 * This is for testing and debuging only and is not internationalized.
 ******************************************************************************
 */
function debug($msg) {
	print("<!--$msg-->\n");
};

/******************************************************************************
 * guilog()
 *
 * This is for testing and debuging only and is not internationalized.
 ******************************************************************************
 */
function guilog($message) {
	global $LOGFILE;

	$fid = fopen($LOGFILE, 'a+');
	fputs($fid, time() . ":\t$message\n");
	fclose($fid);
}

function gotoURL($location) {
	header("Location: $location");
	// Netscape 4.7x and 6 seem to want some data so....
	print('<script>location.href="' . $location . '"</script>');
	exit();
}

function kbToMb($x) {
	return round(($x / 1024), 1);
}

function mbToKb($x) {
	return round($x * 1024);
}

function escQuote($s) {
	$s = preg_replace('/"/', '&quot;', $s);

	return $s;
}

?>
