<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

class MemberList extends ObjectTable {
	
	var $alias;

	function MemberList($aliasObj, $varArray, $id) {


		if ($aliasObj == '') {
			$this = '';
			return;
		} else {
			$this->alias = $aliasObj;
		}

		if ($this->alias->musers) foreach ($this->alias->musers as $m) {
			$this->list[] = new MemberFactory('muser', $m);
		}
		if ($this->alias->maliases) foreach ($this->alias->maliases as $m) {
			$this->list[] = new MemberFactory('malias', $m);
		}
		if ($this->alias->mremotes) foreach ($this->alias->mremotes as $m) {
			$this->list[] = new MemberFactory('mremote', $m);
		}

		// Setup the table
		if (Table::isActive($varArray, $id)) {
			$table = Table::getActive();
			$table->setParams($varArray, $this->count());

			$this->setActionExtra('&mail=' . $this->alias->mail);
		} else {
			$table = new Table($id);

			$name = getIntlMsg('MSG_MEMBERS_HEADING_ADDRESS');
			$table->addDataColumn($name, Column::ASCEND(),
				'address');

			$name = getIntlMsg('MSG_MEMBERS_HEADING_CLASS');
			$table->addDataColumn($name, Column::ASCEND(),
				'class');

			if ($this->alias->isOwner($GLOBALS['session_user']) ||
				isAdmin()) {
			$name = getIntlMsg('MSG_MEMBERS_HEADING_REMOVE');
			$table->addDisplayColumn($name,
				"return Go('aliasremove_action.php?mail=" .
				$this->alias->mail . 
				"&_mgenerics=%%ROWID%%')");
			}

			$table->setParams($HTTP_GET_VARS, $this->count());
			$table->rows = $GLOBALS['MEMBERS_TABLE_ROWS'];
			$table->setSortedColumn($table->firstSortedColumn());

			$this->setActionExtra('&mail=' . $this->alias->mail);
		}

		// Apply sorting
		$attr = $table->getSortAttrName($table->getSortedColumn());
		$dir  = $table->getColumnSortDir($table->getSortedColumn());
		$this->sort(Member::comparisonFunctionName($attr ,$dir));

		// Save table
		$this->table = $table;
		$this->table->save();
	}

	function _addLink($value, $id, $class) {
		$retval = '';
		$close = false;
		if ($class == 'memberuser') {
			$retval .= '<a href="userview.php?mail=' . $id . '">';
			$close = true;
		} elseif ($class == 'memberalias') {
			$retval .= '<a href="aliasview.php?mail=' . $id . '">';
			$close = true;
		}

		$retval .= $value;

		if ($close) {
			$retval .= '</a>';
		}

		return $retval;
	}


	function getListValue($index, $col = '') {
		global $session_lang;

		// if no $col then return the row value (unique id)
		if ($col === '') return $this->list[$index]->getMail();

		$mgeneric = $this->list[$index];
		$class = get_class($mgeneric);

		switch ($col) {
			case '0':
			case 'address':
				$retval = $this->_addLink(
					$mgeneric->getName(),
					$mgeneric->getMail(),
					$class);
				break;
			case '1':
			case 'class':
				$retval = $mgeneric->getClass();
				break;
			case '2' :
				$retval = $this->table->getTemplate('deleteIcon');
				$retval = ereg_replace('%%LANG%%', $session_lang, $retval);
				$retval = stripslashes($retval);
				break;
			default:
				$retval = '';
				break;
		}

		return $retval;
	}

	function getNav() {
		global $_SELF, $_SERIAL;
	
		$current = (int)($this->table->offset / $this->table->rows) + 1;

		$total = (int)($this->count() / $this->table->rows);
		if ($this->count() % $this->table->rows > 0) {
			$total++;
		} elseif ($this->count() == 0) {
			$total = 1;
		}
	
		$retval = '<div class="tablenav">';
		$retval .= getIntlMsg('MSG_TABLE_CURRENT_PAGE',
			   $current, $total);
		if ($total == 1) {
			return $retval;
		}
 		$retval .= ' ' . getIntlMsg('MSG_TABLE_CURRENT_SEP') . ' ';
		if ($current > 1) {
			$offset = ($current - 2) * $this->table->rows;
			$href = $_SELF .
				'?mail='   . $this->alias->mail .
				'&offset=' .  $offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . 
				 '" class="tablenav">' .
				getIntlMsg('MSG_TABLE_PAGE_PREV') . '</a> ';
		}
		for ($i = 1; $i <= $total; $i++) {
			$offset = ($i - 1) * $this->table->rows;
			$href = $_SELF .  
				'?mail=' . $this->alias->mail .
				'&offset=' . $offset .
				'&serial=' . $_SERIAL;
			if ($current != $i) {
				$retval .= ' <a href="' . $href . 
					'" class="tablenav">' . $i . '</a> ';
			} else {
				$retval .= " $i ";
			}
		}
		if ($current < $total) {
			$offset = ($current) * $this->table->rows;
			$href = $_SELF .  
				'?mail=' . $this->alias->mail . 
				'&offset=' . $offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . 
				'" class="tablenav">' . 
				getIntlMsg('MSG_TABLE_PAGE_NEXT') . '</a> ';
		}
		$retval .= '</div>' . "\n";

		return $retval;

	}

	function renderList() {
		$retval = '<div style="background-color:white;width:475;height:100;overflow:auto;text-align:left;padding:5">' . "\n";
		$first = true;
		foreach ($this->list as $mgeneric) {
			if (! $first) {
				$retval .= getIntlMsg('MSG_LISTSEP') . "\n";
			} else {
				$first = false;
			}

			$close = false;
			$class = get_class($mgeneric);
			if ($class == 'muser') {
				$retval .= '<a href="userview.php?mail=' . $mgeneric->name . '">';
				$close = true;
			} elseif ($class == 'malias') {
				$retval .= '<a href="aliasview.php?mail=' . $mgeneric->name . '">';
				$close = true;
			}

			$retval .= "$mgeneric->name";

			if ($close) {
				$retval .= '</a>';
			}
		}
		$retval .= '</div>' . "\n";

		return $retval;
	}
}

class MemberFactory {
	function MemberFactory($type, $id) {
		switch ($type) {
			case 'owner':
				$this = new MemberOwner($id);
				break;
			case 'user':
			case 'muser':
				$this = new MemberUser($id);
				break;
			case 'alias':
			case 'malias':
				$this = new MemberAlias($id);
				break;
			case 'remote':
			case 'mremote':
				$this = new MemberRemote($id);
				break;
			case 'file':
				$this = new MemberFile($id);
				break;
			case 'program':
				$this = new MemberProgram($id);
				break;
			default:
				$this = '';
				break;
		}
	}
}

class Member {
	var $id;
	var $name;
	var $classid;
	var $class;

	function Member($id) {
		$this->id = $id;
		$this->classid = 'generic';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_GENERIC');
	}

	function isLocal() {
	}

	function isAlias() {
		return false;
	}

	function isUser() {
		return false;
	}

	function getClass() {
		return $this->class;
	}

	function getClassId() {
		return $this->classid;
	}

	function comparisonFunctionName($field, $direction) {
		switch($field) {
			case 'id':
				$cmpFunction = '_mgeneric_byId';
				break;
			case 'name':
				$cmpFunction = '_mgeneric_byName';
				break;
			case 'class':
				$cmpFunction = '_mgeneric_byClass';
				break;
			default:
				$cmpFunction = '_mgeneric_byName';
				break;
		}

		switch($direction) {
			case 'a':
				$cmpFunction .= 'Ascend';
				break;
			case 'd':
				$cmpFunction .= 'Decend';
				break;
			default:
				$cmpFunction .= 'Acend';
				break;
		}
		return $cmpFunction;
	}

	function getId() {
		return $this->id;
	}

	function getMail() {
		return $this->name;
	}

	function getName() {
		$pos = strpos($this->name, '@');
		if ($pos === false) {
			$retval = $this->name;
		} else {
			$retval = substr($this->name, 0, $pos);
		}
		
		return $retval;
	}
}

/*
 * Ideally these comparison functions would be encapsulated in the 
 * User class as class methods. Can't work out how to pass a class
 * method to the usort() function yet.
 */
function _mgeneric_byIdAscend($left, $right) {
	return(strcasecmp($left->id,$right->id));
}

function _mgeneric_byIdDecend($left, $right) {
	return(-1 * (_mgeneric_byIdAscend($left, $right)));
}

function _mgeneric_byNameAscend($left, $right) {
	return(strcasecmp($left->name,$right->name));
}

function _mgeneric_byNameDecend($left, $right) {
	return(-1 * (_mgeneric_byNameAscend($left, $right)));
}

function _mgeneric_byClassAscend($left, $right) {
	return(strcasecmp($left->class,$right->class));
}

function _mgeneric_byClassDecend($left, $right) {
	return(-1 * (_mgeneric_byClassAscend($left, $right)));
}


class MemberUser extends Member {
	var $obj;

	function MemberUser($id) {
		$this->Member($id);
		$this->name=$id;
		$this->classid = 'user';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_USER');
	}
	
	function isUser() {
		return true;
	}

}

class MemberOwner extends MemberUser {
	var $obj;

	function MemberOwner($id) {
		$this->MemberUser($id);
		$this->classid = 'owner';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_OWNER');
	}

}

class MemberAlias extends Member {
	var $obj;

	function MemberAlias($id) {
		$this->Member($id);
		$this->name=$id;
		$this->classid = 'alias';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_ALIAS');
	}

	function isAlias() {
		return true;
	}

}

class MemberRemote extends Member {
	function MemberRemote($id) {
		$this->Member($id);
		$this->name=$id;
		$this->classid = 'remote';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_REMOTE');
	}

	function getName() {
		return $this->name;
	}
}

class MemberFile extends Member {
	function MemberFile($id) {
		$this->Member($id);
		$this->classid = 'file';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_FILE');
	}
}

class MemberProgram extends Member {
	function MemberProgram($id) {
		$this->Member($id);
		$this->classid = 'program';
		$this->class = getIntlMsg('MSG_ALIASES_MEMBER_CLASS_PROGRAM');
	}
}

?>
