%define name perl-Msgcat
%define real_name Msgcat
%define version 1.03
%define release 1
%define archive %real_name-%version.tar.gz

Summary:	Msgcat, a small Perl module for XPG4 message catalog functions
Name:		%{name}
Version: 	%{version}
Release: 	%{release}
License: 	GPL
Group: 		Applications/CPAN
Source:		ftp://ftp.pasteur.fr/pub/computing/CPAN/modules/by-module/Locale/%archive
Requires:	perl >= 5.6.0
Requires:	make >= 3.79.1
Buildroot:	%{_tmppath}/%{name}-%{version}
URL:		http://www.cpan.org

%Description
This is Msgcat, a small Perl modules for systems which support the XPG4 message
catalog functions : catopen(3), catgets(3) and catclose(4).

%Prep
%setup -q -n %{real_name}-%{version}

%Build
rm -rf %{buildroot}
CFLAGS="$RPM_OPT_FLAGS" %{__perl} Makefile.PL
make
make test

%Install
mkdir -p %{buildroot}
DESTDIR=%{buildroot}

eval `perl '-V:sitearch'`
eval `perl '-V:installprefix'`
eval `perl '-V:installstyle'`
eval `perl '-V:installman1dir'`
eval `perl '-V:installman3dir'`

PREFIX=$DESTDIR
PLOCAL=$installprefix/$installstyle/perllocal

mkdir -p $PREFIX/$sitearch
mkdir -p $PREFIX/$PLOCAL

make PREFIX=$PREFIX%{_prefix} install \
INSTALLMAN1DIR=$PREFIX$installman1dir \
INSTALLMAN3DIR=$PREFIX$installman3dir

#Get the file "perllocal.pod" location
mv `find $PREFIX -type f -print | grep perllocal.pod` perllocal.pod
perl -pi -e "s@$PREFIX@@g" perllocal.pod
echo $PLOCAL/%{name}-perllocal.pod > podfile_full.lst

cp perllocal.pod $PREFIX/$PLOCAL/%{name}-perllocal.pod
cp podfile_full.lst $PREFIX/$PLOCAL/%{name}-podfile_full.lst

# gzip man pages
find $PREFIX/$installman3dir $PREFIX/$installman1dir -type f -print | xargs gzip

# create file list
#find $DESTDIR%{_prefix} -type f -print | sed "s@^$DESTDIR@@g" | grep -v perllocal.pod > %{real_name}-%{version}-filelist
find $PREFIX -type f -print | sed "s@^$PREFIX@@g" > %{real_name}-%{version}-filelist

%Clean 
rm -rf %{buildroot}

%Files -f %{real_name}-%{version}-filelist
%defattr(0644,root,root,0755)

%Post
# update pod - adjusts the date too
eval `perl '-V:installprefix'`
eval `perl '-V:installstyle'`
PLOCAL=$installprefix/$installstyle/perllocal
perl -p -e '$t=localtime;s@(^=head2 ).*(:.*)$@$1$t$2@' $PLOCAL/%{name}-perllocal.pod >> `perl -p -e '' $PLOCAL/%{name}-podfile_full.lst`

%Changelog
