#!/bin/bash
#
# Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
#

NAME="SCOoffice Mail Server"
KDESU=kdesu
KDEDIRS=/opt/kde2
CURDIR=`dirname $0`

UNITEDLINUX=`$CURDIR/installation/resources/platform.sh --ul`
if [ "$UNITEDLINUX" -eq 1 ]
then
	XMLFILE="msg-install-ul.xml"
else
	XMLFILE="msg-install.xml"
fi


if [ "$1" = '-c' ]
then
	if [ "$UNITEDLINUX" -eq 1 ];then
		LAUNCH_CMD="$CURDIR/installation/cmdinstall-ul.sh"
		OUTPUT_CMD=""
	else
		LAUNCH_CMD="$CURDIR/installation/cmdinstall.sh"
		OUTPUT_CMD=""
	fi
else
	LAUNCH_CMD="$CURDIR/installation/openif $CURDIR/installation/$XMLFILE"
	OUTPUT_CMD="> /var/tmp/install.output 2>&1";
fi

if test `id -u` -eq 0 ; then
    sh -c "$LAUNCH_CMD $OUTPUT_CMD"
else
    if [ -x $KDEDIRS/bin/$KDESU ]; then
        $KDEDIRS/bin/$KDESU --caption "$NAME installation" $LAUNCH_CMD > /var/tmp/install.output 2>&1
    fi
fi

