#!/bin/bash
#
# Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
#
# NOTE: This script is not called by the graphic installation utility.
#

# Store the path to the script
SCRIPTPATH=`dirname $0`

UNITEDLINUX=`$SCRIPTPATH/platform.sh --ul`;	
UNIXWARE=`$SCRIPTPATH/platform.sh --uw`

USERNAME=`id -un`
if [ "$USERNAME" != "root" ] ; then
    echo " "
    echo "You must be root to run this script"
    exit 1
fi

# the common part of the preinstall (used by both this script and graphical).
# If the execution fails, don't run the rest of the preinstall.sh script
if ! $SCRIPTPATH/preinstall2.sh; then
	echo "Exiting from preinstall.sh..." >&2
	exit 1
fi

if [ $UNIXWARE -eq 1 ]; then
	$SCRIPTPATH/lkp_master lkp_msg
	exit 0
fi

if [ $UNITEDLINUX -eq 1 ]; then
	INITPATH="/etc/rc.d"
else
	INITPATH="/etc/rc.d/init.d"
fi

[ -f $INITPATH/postfix ] && $INITPATH/postfix stop >/dev/null 2>&1
[ -f $INITPATH/cyrus   ] && $INITPATH/cyrus   stop >/dev/null 2>&1
[ -f $INITPATH/ldap    ] && $INITPATH/ldap    stop >/dev/null 2>&1
[ -f $INITPATH/mta     ] && $INITPATH/mta     stop >/dev/null 2>&1

if rpm -q sendmail > /dev/null 2>&1; then
	# make sure sendmail is really, absolutely, positively, truely dead
	killall -9 sendmail
	rpm -e sendmail-cf >> $1 2>&1
	rpm -e sendmail-doc >> $1 2>&1
	rpm -e sendmail >> $1 2>&1
fi

if rpm -q imap-2000 > /dev/null 2>&1; then
	rpm -e imap-2000 >> $1 2>&1
	rpm -e imap-devel-2000 >> $1 2>&1
fi

if [ $UNITEDLINUX -eq 1 ]; then
	[ -e /usr/lib/perl5/site-perl ] || { \
		cd /usr/lib/perl5; \
		ln -s site_perl site-perl; \
	}
fi
