#
#  File: msg-horde.spec
#
#  This is the SPEC file for the Horde used with msg (RPM v4) RPMs/SRPM.
#

%define name scomsg-horde
%define version 2.1
%define release 4ul
%define apachedir /etc/httpd
%define apacheuser wwwrun
%define apachegroup www
%define contentdir /opt/lsb-sco.com/msg
%define phpini /etc/php.ini
%define hordeconf %{name}.conf

Summary: The common Horde Framework for all Horde modules.
Name: %name
Version: %version
Release: %release
Copyright: LGPL
Group: Applications/Horde
Source: ftp://ftp.horde.org/pub/horde/tarballs/horde-%{version}.tar.gz
Source1: %{hordeconf}
Patch0: %{name}-%{version}-theme.patch
Vendor: The Horde Project
URL: http://www.horde.org/
Packager: Bill Welch<billw@sco.com>
BuildArchitectures: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}
Requires: php >= 4.1.0
Requires: apache >= 1.3.22
Prereq: /usr/bin/perl

%description
The Horde Framework provides a common structure and interface for Horde
applications (such as IMP, a web-based mail program).  This RPM is
required for all other Horde module RPMs.

The Horde Project writes web applications in PHP and releases them under
Open Source licenses.  For more information (including help with Horde
and its modules) please visit http://www.horde.org/.

%prep
%setup -q -n horde-%{version}
%patch0 -p1

%build

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{apachedir}
cp -p $RPM_SOURCE_DIR/%{hordeconf} $RPM_BUILD_ROOT%{apachedir}
mkdir -p $RPM_BUILD_ROOT%{contentdir}/horde
cp -pR * $RPM_BUILD_ROOT%{contentdir}/horde
chmod go-rwx $RPM_BUILD_ROOT%{contentdir}/horde/test.php
cd $RPM_BUILD_ROOT%{contentdir}/horde/config
for d in *.dist; do
	d0=`basename $d .dist`
	if [ ! -f "$d0" ]; then
		cp -p $d $d0
	fi
done

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
perl -pi -e 's/=\s*Off/= On/i if (/file_uploads\s*=\s*Off/i);' %{phpini}
perl -pi -e 's/$/ index.php/ if (/DirectoryIndex\s.*index\.html/ && !/index\.php/);' %{apachedir}/httpd.conf

perl -pi -e 's/^/#/ if (/Include.*horde.conf$/i);' %{apachedir}/httpd.conf
grep -i "Include.*%{hordconf}\$" %{apachedir}/httpd.conf >/dev/null 2>&1
if [ $? -eq 0 ]; then
	perl -pi -e 's/^#+// if (/Include.*%{hordeconf}$/i);' %{apachedir}/httpd.conf
else
	echo "Include %{apachedir}/%{hordeconf}" >>%{apachedir}/httpd.conf
fi
# post-install instructions:
for i in %{contentdir}/horde/config/*.dist; do
	cp $i `dirname $i`/`basename $i .dist`
done

cat <<_EOF_
You must manually configure Horde and create any required database tables!
See "CONFIGURING HORDE" in %{contentdir}/horde/docs/INSTALL
You must also restart Apache with "service httpd restart"!
_EOF_

%postun
if [ $1 -eq 0 ]; then
	perl -pi -e 's/^#+// if (/^Include.*horde.conf$/i);' %{apachedir}/httpd.conf
	perl -pi -e 's/^.*$// if (/^Include.*%{hordeconf}$/i);' %{apachedir}/httpd.conf
	cat <<_EOF2_
You must restart Apache with "service httpd restart"!
_EOF2_
fi

%files
%defattr(-,root,root)
# Apache hordeconf file
%config %{apachedir}/%{hordeconf}
# Include top level with %dir so not all files are sucked in
%dir %{contentdir}/horde
# Include top-level files by hand
%{contentdir}/horde/*.php
# Include these dirs so that all files _will_ get sucked in
%{contentdir}/horde/graphics
%{contentdir}/horde/lib
%{contentdir}/horde/locale
%{contentdir}/horde/po
%{contentdir}/horde/scripts
%{contentdir}/horde/templates
%{contentdir}/horde/util
# Mark documentation files with %doc and %docdir
%doc %{contentdir}/horde/COPYING
%doc %{contentdir}/horde/README
%docdir %{contentdir}/horde/docs
%{contentdir}/horde/docs
# Mark configuration files with %config and use secure permissions
# (note that .dist files are considered software; don't mark %config)
%attr(750,root,%{apachegroup}) %dir %{contentdir}/horde/config
%defattr(640,root,%{apachegroup})
%{contentdir}/horde/config/.htaccess
%{contentdir}/horde/config/*.dist
%config %{contentdir}/horde/config/*.php

%changelog
* Tue Jun 25 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 3

* Mon Jun 24 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 2 (private beta)

* Thu Jun 13 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 1 (private beta)

* Wed Jan 02 2002 Brent J. Nordquist <bjn@horde.org>
- 2.0 release 1

* Mon Dec 24 2001 Brent J. Nordquist <bjn@horde.org>
- 2.0-RC4 release 1

* Sat Dec 15 2001 Brent J. Nordquist <bjn@horde.org>
- rewritten for Horde 2.0

* Wed Nov 14 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.7 release 1rh7

* Sat Jul 21 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.6 release 1rh7

* Tue Feb 06 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.4 release 1rh7

