#
#  File: scomsg-imp.spec
#
#  This is the SPEC file for the IMP UnitedLinux (RPM v4) RPMs/SRPM.
#

%define name scomsg-imp
%define version 3.1
%define release 4ul
%define apachedir /etc/httpd
%define apacheuser wwwrun
%define apachegroup www
%define contentdir /opt/lsb-sco.com/msg

Name: %name
Version: %version
Release: %release
Summary: The Internet Messaging Program: webmail access to IMAP/POP3 accounts.
Copyright: GPL
Group: Applications/Horde
Source: ftp://ftp.horde.org/pub/imp/tarballs/imp-%{version}.tar.gz
Source1: %{name}.conf
Source2: %{name}-%{version}-theme.tar.gz
Patch0: %{name}-%{version}-vdomain.patch
Patch1: %{name}-%{version}-theme.patch
Vendor: The Horde Project
URL: http://www.horde.org/
Packager: Bill Welch<billw@sco.com>
BuildArchitectures: noarch
BuildRoot: %{_destdir}
Requires: mod_php >= 4.1.0
#Requires: php-imap >= 4.1.0
Requires: apache >= 1.3.22
Requires: scomsg-horde >= 2.0
Prereq: /usr/bin/perl

%description
IMP is the Internet Messaging Program, one of the Horde applications.
It provides webmail access to IMAP and POP3 accounts.

The Horde Project writes web applications in PHP and releases them under
Open Source licenses.  For more information (including help with IMP)
please visit http://www.horde.org/.

%prep
%setup -q -n imp-%{version}
%patch0 -p1
%patch1 -p1

%build

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{apachedir}
cp -p $RPM_SOURCE_DIR/%{name}.conf $RPM_BUILD_ROOT%{apachedir}
mkdir -p $RPM_BUILD_ROOT%{contentdir}/horde/imp
cp -pR * $RPM_BUILD_ROOT%{contentdir}/horde/imp
tar xvzfC %{SOURCE2} $RPM_BUILD_ROOT%{contentdir}/horde/imp
chmod go-rwx $RPM_BUILD_ROOT%{contentdir}/horde/imp/test.php
cd $RPM_BUILD_ROOT%{contentdir}/horde/imp/config
for d in *.dist; do
	d0=`basename $d .dist`
	if [ ! -f "$d0" ]; then
		cp -p $d $d0
	fi
done

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre

%post
perl -pi -e 's/$/ index.php/ if (/DirectoryIndex\s.*index\.html/ && !/index\.php/);' %{apachedir}/httpd.conf
grep -i 'Include.*scomsg-imp.conf$' %{apachedir}/httpd.conf >/dev/null 2>&1
if [ $? -eq 0 ]; then
	perl -pi -e 's/^#+// if (/Include.*scomsg-imp.conf$/i);' %{apachedir}/httpd.conf
else
	echo "Include %{apachedir}/scomsg-imp.conf" >>%{apachedir}/httpd.conf
fi
# post-install instructions:
for i in %{contentdir}/horde/config/*.dist; do
	cp $i `dirname $i`/`basename $i .dist`
done

cat <<_EOF_
You must manually configure IMP!
See "CONFIGURING IMP" in %{contentdir}/horde/imp/docs/INSTALL
You must also restart Apache with "service httpd restart"!
_EOF_

%postun
if [ $1 -eq 0 ]; then
	perl -pi -e 's/^/#/ if (/^Include.*scomsg-imp.conf$/i);' %{apachedir}/httpd.conf
	cat <<_EOF2_
You must restart Apache with "service httpd restart"!
_EOF2_
fi

%files
%defattr(-,root,root)
# Apache scomsg-imp.conf file
%config %{apachedir}/scomsg-imp.conf
# Include top level with %dir so not all files are sucked in
%dir %{contentdir}/horde/imp
# Include top-level files by hand
%{contentdir}/horde/imp/*.php
# Include these dirs so that all files _will_ get sucked in
%{contentdir}/horde/imp/graphics
%{contentdir}/horde/imp/lib
%{contentdir}/horde/imp/locale
%{contentdir}/horde/imp/po
%{contentdir}/horde/imp/scripts
%{contentdir}/horde/imp/templates
# Mark documentation files with %doc and %docdir
%doc %{contentdir}/horde/imp/COPYING
%doc %{contentdir}/horde/imp/README
%docdir %{contentdir}/horde/imp/docs
%{contentdir}/horde/imp/docs
# Mark configuration files with %config and use secure permissions
# (note that .dist files are considered software; don't mark %config)
%attr(750,root,%{apachegroup}) %dir %{contentdir}/horde/imp/config
%defattr(640,root,%{apachegroup})
%{contentdir}/horde/imp/config/.htaccess
%{contentdir}/horde/imp/config/*.dist
%config %{contentdir}/horde/imp/config/*.php
%config %{contentdir}/horde/imp/config/*.txt

%changelog
* Mon Dec 23 2002 Bill Welch <billw@sco.com>
- 3.1 release 3ul modified for SCOoffice Mail Server on UnitedLinux

* Mon Jun 24 2002 Brent J. Nordquist <bjn@horde.org>
- 3.1 release 2

* Thu Jun 13 2002 Brent J. Nordquist <bjn@horde.org>
- 3.1 release 1 (private beta)

* Wed Jan 02 2002 Brent J. Nordquist <bjn@horde.org>
- 3.0 release 1

* Mon Dec 24 2001 Brent J. Nordquist <bjn@horde.org>
- 3.0-RC4 release 1

* Sat Dec 15 2001 Brent J. Nordquist <bjn@horde.org>
- rewritten for IMP 3.0

* Wed Nov 14 2001 Brent J. Nordquist <bjn@horde.org>
- 2.2.7 release 1rh7

* Sat Jul 21 2001 Brent J. Nordquist <bjn@horde.org>
- 2.2.6 release 1rh7

* Tue Feb 06 2001 Brent J. Nordquist <bjn@horde.org>
- 2.2.4 release 1rh7

